### Hierarchy

- BaseForLines
  - ISimpleBracket
    - SimpleBracket
    - SimpleEllipsisBracket

### Implements

- ICacheable

## Index

### Constructors

- constructor

### Properties

- __coverageCount
- __source
- debugFlag
- direction
- firstCells

### Methods

- __getLineAndColumnRange
- __getSourceLineAndColumn
- __incrementCoverage
- _getAllNeighbors
- addCell
- addCellsToEmptyRules
- clearCaches
- getMatches
- hasMatches
- prepareAction
- removeCell
- subscribeToNeighborChanges
- toKey
- toSourceString
- toString

## Constructors

### constructor

- new ISimpleBracket(source: IGameCode, direction: RULE_DIRECTION, allNeighbors: SimpleNeighbor[], debugFlag: Optional<DEBUG_FLAG>): ISimpleBracket

- Overrides BaseForLines.constructor

  - Defined in models/rule.ts:628

  #### Parameters

  - ##### source: IGameCode

  - ##### direction: RULE_DIRECTION

  - ##### allNeighbors: SimpleNeighbor[]

  - ##### debugFlag: Optional<DEBUG_FLAG>

  #### Returns ISimpleBracket

## Properties

### __coverageCount

__coverageCount: Optional<number>

Inherited from BaseForLines.__coverageCount

- Defined in models/BaseForLines.ts:69

### __source

__source: IGameCode

Inherited from BaseForLines.__source

- Defined in models/BaseForLines.ts:68

### debugFlag

debugFlag: Optional<DEBUG_FLAG>

- Defined in models/rule.ts:625

### direction

direction: RULE_DIRECTION

- Defined in models/rule.ts:626

### Protected firstCells

firstCells: Set<Cell>

- Defined in models/rule.ts:627

## Methods

### __getLineAndColumnRange

- __getLineAndColumnRange(): object

- Inherited from BaseForLines.__getLineAndColumnRange

  - Defined in models/BaseForLines.ts:96

  #### Returns object

  - ##### end: object

    - ##### col: number

    - ##### line: number

  - ##### start: object

    - ##### col: number

    - ##### line: number

### __getSourceLineAndColumn

- __getSourceLineAndColumn(): object

- Inherited from BaseForLines.__getSourceLineAndColumn

  - Defined in models/BaseForLines.ts:81

  #### Returns object

  - ##### colNum: number

  - ##### line: string

  - ##### lineNum: number

  - ##### nextLine: null | string

  - ##### prevLine: null | string

### __incrementCoverage

- __incrementCoverage(): void

- Inherited from BaseForLines.__incrementCoverage

  - Defined in models/BaseForLines.ts:104

  #### Returns void

### _getAllNeighbors

- _getAllNeighbors(): SimpleNeighbor[]

- - Defined in models/rule.ts:646

  #### Returns SimpleNeighbor[]

### Abstract addCell

- addCell(index: number, neighbor: SimpleNeighbor, t: SimpleTileWithModifier, sprite: GameSprite, cell: Cell, wantsToMove: Optional<RULE_DIRECTION>): void

- - Defined in models/rule.ts:641

  #### Parameters

  - ##### index: number

  - ##### neighbor: SimpleNeighbor

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cell: Cell

  - ##### wantsToMove: Optional<RULE_DIRECTION>

  #### Returns void

### Abstract addCellsToEmptyRules

- addCellsToEmptyRules(cells: Iterable<Cell>): void

- - Defined in models/rule.ts:643

  #### Parameters

  - ##### cells: Iterable<Cell>

  #### Returns void

### Abstract clearCaches

- clearCaches(): void

- - Defined in models/rule.ts:639

  #### Returns void

### Abstract getMatches

- getMatches(level: Level, actionBracket: Optional<ISimpleBracket>): MatchedCellsForRule[]

- - Defined in models/rule.ts:644

  #### Parameters

  - ##### level: Level

  - ##### actionBracket: Optional<ISimpleBracket>

  #### Returns MatchedCellsForRule[]

### hasMatches

- hasMatches(level: Level, actionBracket: Optional<ISimpleBracket>): boolean

- - Defined in models/rule.ts:649

  #### Parameters

  - ##### level: Level

  - ##### actionBracket: Optional<ISimpleBracket>

  #### Returns boolean

### Abstract prepareAction

- prepareAction(action: ISimpleBracket): void

- - Defined in models/rule.ts:640

  #### Parameters

  - ##### action: ISimpleBracket

  #### Returns void

### Abstract removeCell

- removeCell(index: number, neighbor: SimpleNeighbor, t: SimpleTileWithModifier, sprite: GameSprite, cell: Cell): void

- - Defined in models/rule.ts:642

  #### Parameters

  - ##### index: number

  - ##### neighbor: SimpleNeighbor

  - ##### t: SimpleTileWithModifier

  - ##### sprite: GameSprite

  - ##### cell: Cell

  #### Returns void

### Abstract subscribeToNeighborChanges

- subscribeToNeighborChanges(): void

- - Defined in models/rule.ts:637

  #### Returns void

### Abstract toKey

- toKey(ignoreDebugFlag?: undefined | false | true): string

- - Defined in models/rule.ts:638

  #### Parameters

  - ##### Optional ignoreDebugFlag: undefined | false | true

  #### Returns string

### toSourceString

- toSourceString(): string

- Inherited from BaseForLines.toSourceString

  - Defined in models/BaseForLines.ts:90

  #### Returns string

### toString

- toString(): string

- Inherited from BaseForLines.toString

  - Defined in models/BaseForLines.ts:85

  #### Returns string

Generated using TypeDoc